-----------------------------------------------------------------------------------------------
-- Client Lua Script for ClearTarget
-----------------------------------------------------------------------------------------------
local ClearTarget = {} 
 
-----------------------------------------------------------------------------------------------
-- Initialization
-----------------------------------------------------------------------------------------------
function ClearTarget:new(o)
    o = o or {}
    setmetatable(o, self)
    self.__index = self 
    return o
end

function ClearTarget:Init()
	local bHasConfigureFunction = false
	local strConfigureButtonText = ""
	local tDependencies = {}
    Apollo.RegisterAddon(self, bHasConfigureFunction, strConfigureButtonText, tDependencies)
end
 

-----------------------------------------------------------------------------------------------
-- ClearTarget OnLoad
-----------------------------------------------------------------------------------------------
function ClearTarget:OnLoad()    
	Apollo.RegisterSlashCommand("cleartarget", "OnSlashClearTarget", self)
	Apollo.RegisterEventHandler("InterfaceMenuListHasLoaded", "OnInterfaceMenuListHasLoaded", self)
end

-----------------------------------------------------------------------------------------------
-- OnInterfaceMenuListHasLoaded. Called when the interface menu (lower left icon by default) is ready
--TODO: Why are we using this event? Is there a better way to make sure the chat system is up and running?
-- Chose this event because it's what EntSpy uses and that always seems to work for me, but it is kind of 
-- messy to have this just for the one line.
-----------------------------------------------------------------------------------------------
function ClearTarget:OnInterfaceMenuListHasLoaded()
	-- On load (logging in only, sadly, not after a /reloadui), send a message to the chat log 
	-- letting the user know it's running and reminding them what the syntax is. Nothing too spammy.
	self:MessageOut("ClearTarget loaded. Use /cleartarget to target nothing")
end

-----------------------------------------------------------------------------------------------
-- on SlashCommand "/cleartarget"
function ClearTarget:OnSlashClearTarget()
	GameLib.SetTargetUnit(nil)
end

-----------------------------------------------------------------------------------------------
-- Internal methods
-----------------------------------------------------------------------------------------------
-- Using Realm messages for general info to the user
function ClearTarget:MessageOut(str)
	ChatSystemLib.PostOnChannel(ChatSystemLib.ChatChannel_Realm, str)
end

-----------------------------------------------------------------------------------------------
-- ClearTarget Instance
-----------------------------------------------------------------------------------------------
local ClearTargetInst = ClearTarget:new()
ClearTargetInst:Init()
